/**
 * DevExtreme (client_exporter/xlsx/xlsx_cell_format_helper.js)
 * Version: 18.2.0 (build 18254)
 * Build date: Tue Sep 11 2018
 *
 * Copyright (c) 2012 - 2018 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
var _type = require("../../core/utils/type");
var _type2 = _interopRequireDefault(_type);
var _xlsx_tag_helper = require("./xlsx_tag_helper");
var _xlsx_tag_helper2 = _interopRequireDefault(_xlsx_tag_helper);
var _xlsx_cell_alignment_helper = require("./xlsx_cell_alignment_helper");
var _xlsx_cell_alignment_helper2 = _interopRequireDefault(_xlsx_cell_alignment_helper);

function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        "default": obj
    }
}
var XlsxCellFormatHelper = {
    tryCreateTag: function(sourceObj) {
        var result = null;
        if (_type2.default.isDefined(sourceObj)) {
            result = {
                fontId: sourceObj.fontId,
                numberFormatId: sourceObj.numberFormatId,
                alignment: _xlsx_cell_alignment_helper2.default.tryCreateTag(sourceObj.alignment)
            };
            if (XlsxCellFormatHelper.isEmpty(result)) {
                result = null
            }
        }
        return result
    },
    areEqual: function(leftTag, rightTag) {
        return XlsxCellFormatHelper.isEmpty(leftTag) && XlsxCellFormatHelper.isEmpty(rightTag) || _type2.default.isDefined(leftTag) && _type2.default.isDefined(rightTag) && leftTag.fontId === rightTag.fontId && leftTag.numberFormatId === rightTag.numberFormatId && _xlsx_cell_alignment_helper2.default.areEqual(leftTag.alignment, rightTag.alignment)
    },
    isEmpty: function(tag) {
        return !_type2.default.isDefined(tag) || !_type2.default.isDefined(tag.fontId) && !_type2.default.isDefined(tag.numberFormatId) && _xlsx_cell_alignment_helper2.default.isEmpty(tag.alignment)
    },
    toXml: function(tag) {
        if (XlsxCellFormatHelper.isEmpty(tag)) {
            return ""
        } else {
            var isAlignmentEmpty = _xlsx_cell_alignment_helper2.default.isEmpty(tag.alignment);
            var applyNumberFormat = void 0;
            if (0 === tag.numberFormatId) {
                applyNumberFormat = 0
            } else {
                if (_type2.default.isDefined(tag.numberFormatId)) {
                    applyNumberFormat = 1
                }
            }
            return _xlsx_tag_helper2.default.toXml("xf", {
                xfId: 0,
                applyAlignment: isAlignmentEmpty ? null : 1,
                fontId: tag.fontId,
                applyNumberFormat: applyNumberFormat,
                numFmtId: tag.numberFormatId
            }, isAlignmentEmpty ? null : _xlsx_cell_alignment_helper2.default.toXml(tag.alignment))
        }
    }
};
exports.default = XlsxCellFormatHelper;
